require 'util'

local chest_prototype = table.deepcopy(data.raw.container['wooden-chest'])

chest_prototype.name = 'dummy-entity'
chest_prototype.minable.result = 'item-5'

--[[
We want robots to build the dummy-entity with a item-5

In theory, the robot should use the first item according to sorted prototypes order
that has a place_result matching the wanted entity

However, this doesn't seem to be what is actually happening

Here is the result of sorting the items using other sort criteria:

By order of appearance in data.raw: item-{2 4 3 5 1}
By item name: item-{1 2 3 4 5}
By item type and name: item-{3 4 1 2 5}
By item type and order of appearance: item-{4 3 2 5 1}
By order key: item-{5 3 1 4 2}

--]]


local function make(name, type, order)
    return {
        name = 'item-' .. name,
        type = type,
        flags = {},
        order = order,
        icon = '__base__/graphics/icons/signal/signal_' .. name .. '.png',
        stack_size = 1,
        place_result = 'dummy-entity',
    }
end

data:extend{
    chest_prototype,

    make('2', 'item-with-tags', '4'),
    make('4', 'item',           '3'),
    make('3', 'item',           '1'),
    make('5', 'item-with-tags', '0'),
    make('1', 'item-with-tags', '2'),
}

